/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

//import Dropdown from "./dropdown.js"; // dropdown is currently implemented using Bootstrap
import MenuItemElement from "./menu-item.js";

const OBSERVER = new MutationObserver(data => {
	for (const d of data) {
		if (d.target instanceof HTMLMenuElement && d.attributeName === "class" && d.target.classList.contains("dropdown-menu")) {
			const menu = d.target;
			if (!menu.classList.contains("show")) {
				for (const menuitem of menu.querySelectorAll(`menu-item[_moz-menuactive]`)) {
					menuitem.removeAttribute("_moz-menuactive");
				}
			}
		}
	}
});

OBSERVER.observe(document, {
	subtree: true,
	attributes: true
});

for (const btn of document.querySelectorAll('button[type="menu"]')) {
	const parent = btn.parentElement;
	parent.classList.add("dropdown");
	btn.classList.add("dropdown-toggle");
	btn.dataset.toggle = "dropdown";
	const menu = document.getElementById(btn.getAttribute("menu"));
	if (menu) {
		const removeMozMenuactiveAttribute = evt => {
			console.log(evt);
			for (const menuitem of menu.querySelectorAll(`menu-item[_moz-menuactive]`)) {
				menuitem.removeAttribute("_moz-menuactive");
			}
		};
		menu.classList.add("dropdown-menu");
	}
}

for (const menu of document.querySelectorAll('menu[type="context"], menu[type="context-polyfill"]')) {
	menu.type = "context-polyfill";
	{
		let tmp = null;
		for (const submenu of menu.children) {
			if (!(submenu instanceof HTMLMenuElement)) continue;
			if (!tmp) tmp = document.createElement("div");
			menu.replaceChild(tmp,submenu);
			let menuItem = document.createElement("menu-item");
			menuItem.appendChild(submenu);
			menuItem.setAttribute("type","menu");
			menu.replaceChild(menuItem,tmp);
		}
	}
}
